/***************************************************************************\
  "global.h" - Global Variables and Functions (Global Phase)
  Revision 6; 10 Nov 2002 - 16 Jan 2003
  Copyright (C) 2002-2003  Kevin P. Albrecht
\***************************************************************************/

#ifndef GLOBAL_H
#define GLOBAL_H

/////////////////////////
// DEFINES //////////////
/////////////////////////

// External Defines //
// GLOBAL_DEBUG or GLOBAL_RELEASE

/////////////////////////
// INCLUDES /////////////
/////////////////////////

// Standard //

// Local //
#include "global_conv.h"

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

int gnIndent;            // current indentation level
int gnCurrentLine;       // current line number
char *gsCurrentFilename; // hold current filename for error reporting
int gnTables;
int gnErrors;            // syntax errors
bool gbVerbose;          // output verbose debug messages
bool gbFast;             // execute fast, without debug information

//// global_init
//// Initialize global variables
void global_init ()
{
  gnIndent = 0;
  gnCurrentLine = 0;
  gsCurrentFilename = k_new (256);
  gnTables = 0;
  gnErrors = 0;
  gbVerbose = false;
  gbFast = false;
}

void global_deinit ()
{
  k_del (gsCurrentFilename);
}

#ifdef GLOBAL_DEBUG
  void global_debug (char *s)
  {
    if (!s) printf ("<NIL>\n");
    else printf ("<%s>\n", s);
  }

  void global_debugc (char c)
  {
    printf ("<%c>\n", c);
  }

  void global_debugs (char *s1, char *s2)
  {
    if (!s2) printf ("%s; <NIL>\n", s1);
    else printf ("%s; %s\n", s1, s2);
  }
#endif

#ifdef GLOBAL_DEBUG
  #define DEBUG(arg) global_debug(arg)
  #define DEBUGC(arg) global_debugc(arg)
  #define DEBUGS(arg1,arg2) global_debugs((arg1),(arg2))
#else
  #define DEBUG(arg) ;
  #define DEBUGC(arg) ;
  #define DEBUGS(arg1,arg2) ;
#endif

#endif
